#
# create_menus --
#
#       Create all of the menus for tclSadie.
#
# Arguments:
#       none
#
# Results:
#       Creates and packs all of the menubuttons and their
#       menus.
#
proc create_menus {} {
    global SadieVar

    #------------------- File menu ----------------------------------#  
    menubutton $SadieVar(button,file) \
      -text "File" \
      -underline 0 \
      -menu $SadieVar(menu,file)

    menu $SadieVar(menu,file) -tearoff 0

    $SadieVar(menu,file) add cascade \
      -label "New" \
      -menu $SadieVar(menu,file).new

    menu $SadieVar(menu,file).new -tearoff 0

    $SadieVar(menu,file).new add command \
      -label "Uniform" \
      -command uniform_dialog

    $SadieVar(menu,file).new add command \
      -label "Grayscale" \
      -command gray_scale_dialog

    $SadieVar(menu,file).new add command \
      -label "Function" \
      -command function_dialog

    $SadieVar(menu,file).new add command \
      -label "Random" \
      -command random_dialog

    $SadieVar(menu,file).new add separator

    $SadieVar(menu,file).new add command \
      -label "Checkerboard" \
      -command checkerboard_dialog

    $SadieVar(menu,file).new add command \
      -label "Chirp" \
      -command chirp_dialog

    $SadieVar(menu,file).new add command \
      -label "Sine Star" \
      -command sinestar_dialog

    $SadieVar(menu,file).new add command \
      -label "Sine Wave" \
      -command sinewave_dialog

    $SadieVar(menu,file) add command \
      -label "Open Image" \
      -underline 1 \
      -command "open_image_from_file"

    $SadieVar(menu,file) add command \
      -label "Import Image" \
      -command "import_image_from_file"
      
    $SadieVar(menu,file) add command \
      -label "Save Image" \
      -underline 1 \
      -state disabled \
      -command "save_image_to_file"

    $SadieVar(menu,file) add separator

    $SadieVar(menu,file) add command \
      -label "Rename Image" \
      -state disabled \
      -command rename_image_dialog \
    
    $SadieVar(menu,file) add separator

    $SadieVar(menu,file) add command \
      -label "Print Image" \
      -state disabled \
      -command print_image_dialog
      
    $SadieVar(menu,file) add command \
      -label "Print SessionLog" \
      -command print_sessionlog_dialog

    $SadieVar(menu,file) add separator

    $SadieVar(menu,file) add command \
      -label "Close Current Image" \
      -state disabled \
      -command { delete_image }

    $SadieVar(menu,file) add command \
      -label "Close All Images" \
      -state disabled \
      -command { delete_all_images }

    $SadieVar(menu,file) add command \
      -label "Exit" \
      -underline 1 \
      -command {exit_tclSadie}
    #----------------------------------------------------------------#



    #--------------------- Edit Menu --------------------------------#
    menubutton $SadieVar(button,edit) \
      -text "Edit" \
      -menu $SadieVar(menu,edit) \
      -state normal

    menu $SadieVar(menu,edit) -tearoff 0

    $SadieVar(menu,edit) add command \
      -label "Reset Default Parameters" \
      -command set_default_parameters

# Moved to file menu for consistency with IPT
# JE 08/2000
#    $SadieVar(menu,edit) add command \
#      -label "Rename Image" \
#      -command rename_image_dialog \
#      -state disabled
    #----------------------------------------------------------------#


    #---------------------- Contrast Menu ---------------------------#
    menubutton $SadieVar(button,contrast) \
      -text "Contrast" \
      -menu $SadieVar(menu,contrast) \
      -state disabled

    menu $SadieVar(menu,contrast) -tearoff 0


    $SadieVar(menu,contrast) add command \
      -label "Normalize Stretch" \
      -command normalstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Histogram Equalize Stretch" \
      -command histeqstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Linear Stretch" \
      -command linearstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Logarithmic Stretch" \
      -command logstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Piecewise Linear Stretch" \
      -command pwlstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Square Root Stretch" \
      -command rootstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Square Stretch" \
      -command squarestr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Table Lookup Stretch" \
      -command tlookupstr_dialog

    $SadieVar(menu,contrast) add separator

    $SadieVar(menu,contrast) add command \
      -label "Requantize Graylevels" \
      -command requantstr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Saturate Graylevels" \
      -command saturatestr_dialog

    $SadieVar(menu,contrast) add command \
      -label "Threshold Graylevels" \
      -command threshstr_dialog

    $SadieVar(menu,contrast) add separator

    $SadieVar(menu,contrast) add command \
      -label "Adaptive Stretch" \
      -command adaptstr_dialog

    $SadieVar(menu,contrast) add separator

    $SadieVar(menu,contrast) add command \
      -label "Reference Stretch" \
      -command referencestr_dialog \
      -state disabled

    #----------------------------------------------------------------#


    #--------------------- Filter Menu ------------------------------#
    menubutton $SadieVar(button,filter) \
      -text "Filter" \
      -menu $SadieVar(menu,filter) \
      -state disabled

    menu $SadieVar(menu,filter) -tearoff 0

    $SadieVar(menu,filter) add command \
      -label "Power Spectrum" \
      -command powerspect_dialog

    $SadieVar(menu,filter) add separator

    $SadieVar(menu,filter) add command \
      -label "FFT Convolution" \
      -command fftconv_dialog

    $SadieVar(menu,filter) add command \
      -label "FFT Filter" \
      -command fftfilter_dialog

    $SadieVar(menu,filter) add command \
      -label "FFT (Fast Fourier Transform)" \
      -command fft_dialog

    $SadieVar(menu,filter) add command \
      -label "FHT (Fast Hartley Transform)" \
      -command fht_dialog

    $SadieVar(menu,filter) add separator

    $SadieVar(menu,filter) add command \
      -label "Convolution" \
      -command conv_dialog

    $SadieVar(menu,filter) add command \
      -label "Gradient (Library Mask)" \
      -command gradientlib_dialog

    $SadieVar(menu,filter) add command \
      -label "Gradient (User Mask)" \
      -command gradientuser_dialog

    $SadieVar(menu,filter) add separator

    $SadieVar(menu,filter) add command \
      -label "Variance Map" \
      -command varmap_dialog

    $SadieVar(menu,filter) add command \
      -label "Diversity Map" \
      -command diversmap_dialog

    $SadieVar(menu,filter) add command \
      -label "Majority Filter" \
      -command majorfilt_dialog

    $SadieVar(menu,filter) add command \
      -label "Median Filter" \
      -command medianfilt_dialog

    $SadieVar(menu,filter) add command \
      -label "Minimum Filter" \
      -command minfilt_dialog

    $SadieVar(menu,filter) add command \
      -label "Maximum Filter" \
      -command maxfilt_dialog

    $SadieVar(menu,filter) add command \
      -label "Conditional Average Filter" \
      -command condavgfilt_dialog
    #----------------------------------------------------------------#


    #--------------------- Geometry Menu ----------------------------#
    menubutton $SadieVar(button,geometry) \
      -text "Geometry" \
      -menu $SadieVar(menu,geometry) \
      -state disabled

    menu $SadieVar(menu,geometry) -tearoff 0

    $SadieVar(menu,geometry) add command \
      -label "Average and Subsample" \
      -command avgsubsamp_dialog

    $SadieVar(menu,geometry) add command \
      -label "Window and Subsample" \
      -command winsubsamp_dialog

    $SadieVar(menu,geometry) add separator

    $SadieVar(menu,geometry) add command \
      -label "Scale" \
      -command linearscale_dialog

    $SadieVar(menu,geometry) add command \
      -label "Rotate" \
      -command rotate_dialog

    $SadieVar(menu,geometry) add command \
      -label "Mirror" \
      -command mirror_dialog

    $SadieVar(menu,geometry) add separator

    $SadieVar(menu,geometry) add command \
      -label "Control Points" \
      -command controlpt_image_dialog

    $SadieVar(menu,geometry) add command \
      -label "Polynomial Warp" \
      -command polywarp_dialog

    $SadieVar(menu,geometry) add separator

    $SadieVar(menu,geometry) add command \
      -label "Horizontal Mosaic" \
      -command horizmosaic_dialog

    $SadieVar(menu,geometry) add command \
      -label "Vertical Mosaic" \
      -command vertmosaic_dialog

    $SadieVar(menu,geometry) add command \
      -label "General Mosaic" \
      -command genmosaic_dialog

    $SadieVar(menu,geometry) add command \
      -label "Insert" \
      -command insert_dialog
    #----------------------------------------------------------------#


    #--------------------- Multi Menu -------------------------------#
    menubutton $SadieVar(button,multi) \
      -text "Multi" \
      -menu $SadieVar(menu,multi) \
      -state disabled

    menu $SadieVar(menu,multi) -tearoff 0

    $SadieVar(menu,multi) add command \
      -label "Combine" \
      -command combine_dialog \
      -state disabled

    $SadieVar(menu,multi) add command \
      -label "Compare" \
      -command compare_dialog \
      -state disabled

    $SadieVar(menu,multi) add separator

    $SadieVar(menu,multi) add command \
      -label "Principal Components Transform" \
      -command pct_dialog \
      -state disabled

    $SadieVar(menu,multi) add command \
      -label "Principal Components Stretch" \
      -command pcs_dialog \
      -state disabled

    $SadieVar(menu,multi) add separator

    $SadieVar(menu,multi) add command \
      -label "RGB -> HSV" \
      -command rgb2hsv_dialog \
      -state disabled

    $SadieVar(menu,multi) add command \
      -label "HSV -> RGB" \
      -command hsv2rgb_dialog \
      -state disabled

    $SadieVar(menu,multi) add separator

    $SadieVar(menu,multi) add command \
      -label "BIL -> BSQ (RGB to 3 Bands)" \
      -command bil2bsq_dialog \
      -state disabled

    $SadieVar(menu,multi) add command \
      -label "BSQ -> BIL (3 Bands to RGB)" \
      -command bsq2bil_dialog

    $SadieVar(menu,multi) add separator

    $SadieVar(menu,multi) add command \
      -label "Complex -> Real" \
      -command complex2real_dialog

    $SadieVar(menu,multi) add command \
      -label "Real -> Complex" \
      -command real2complex_dialog

    $SadieVar(menu,multi) add separator

    $SadieVar(menu,multi) add command \
      -label "Rotate Image Cube Axes" \
      -command rotatecube_dialog
    #----------------------------------------------------------------#


    #--------------------- Classify Menu ----------------------------#
    menubutton $SadieVar(button,classify) \
      -text "Classify" \
      -menu $SadieVar(menu,classify) \
      -state disabled

    menu $SadieVar(menu,classify) -tearoff 0

    $SadieVar(menu,classify) add command \
      -label "LevelSlice" \
      -command levelslice_dialog \
      -state disabled

    $SadieVar(menu,classify) add command \
      -label "Minimum Distance" \
      -command mindistance_dialog \
      -state disabled

    $SadieVar(menu,classify) add command \
      -label "Maximum Likelihood" \
      -command maxlike_dialog \
      -state disabled

    $SadieVar(menu,classify) add command \
      -label "Cluster" \
      -command cluster_dialog

    $SadieVar(menu,classify) add separator

    $SadieVar(menu,classify) add command \
      -label "Segment" \
      -command segment_dialog

    $SadieVar(menu,classify) add separator

    $SadieVar(menu,classify) add command \
      -label "Signature Map" \
      -command sigmap_dialog \
      -state disabled
    #----------------------------------------------------------------#


    #--------------------- Tools Menu -------------------------------#
    menubutton $SadieVar(button,tools) \
      -text "Tools" \
      -menu $SadieVar(menu,tools) \
      -state disabled

    menu $SadieVar(menu,tools) -tearoff 0

    $SadieVar(menu,tools) add command \
      -label "Destripe" \
      -command destripe_dialog

    $SadieVar(menu,tools) add separator

    $SadieVar(menu,tools) add command \
      -label "Contour Map" \
      -command contmap_dialog \
      -state disabled

    $SadieVar(menu,tools) add command \
      -label "Shaded Relief" \
      -command relief_dialog

    $SadieVar(menu,tools) add separator

    $SadieVar(menu,tools) add command \
      -label "Scattergram" \
      -command scattergram_dialog \
      -state disabled

    $SadieVar(menu,tools) add separator

    $SadieVar(menu,tools) add command \
      -label "RMS Difference" \
      -command rmsdiff_dialog \
      -state disabled
    #----------------------------------------------------------------#


    #--------------------- Windows Menu -----------------------------#
    menubutton $SadieVar(button,winlist) \
      -text "Windows" \
      -menu $SadieVar(menu,winlist)

    menu $SadieVar(menu,winlist) -tearoff 0

    $SadieVar(menu,winlist) add checkbutton \
      -label "Full Color" \
      -variable SadieVar(fullcolor)

    $SadieVar(menu,winlist) add separator

    $SadieVar(menu,winlist) add command \
      -label "Main Window" \
      -command "raise ."

    $SadieVar(menu,winlist) add command \
      -label "Session Log" \
      -command "raise .sessionlog"

    $SadieVar(menu,winlist) add separator
    #----------------------------------------------------------------#


    #--------------------- Help Menu --------------------------------#
    menubutton $SadieVar(button,help) \
      -text "Help" \
      -menu $SadieVar(menu,help) \
      -state disabled

    menu $SadieVar(menu,help) -tearoff 0
    #----------------------------------------------------------------#


    pack $SadieVar(button,file) \
      $SadieVar(button,edit) \
      $SadieVar(button,contrast) \
      $SadieVar(button,filter) \
      $SadieVar(button,geometry) \
      $SadieVar(button,multi) \
      $SadieVar(button,classify) \
      $SadieVar(button,tools) \
      $SadieVar(button,winlist) \
      -side left

    pack $SadieVar(button,help) -side right
}



proc verify_menus {} {
    global SadieVar
    
    foreach menuname [list file edit contrast filter geometry multi classify tools new] {
	if {$menuname == "new"} {
	    set themenu $SadieVar(menu,file).new
	} else {
	    set themenu $SadieVar(menu,$menuname)
	}

	if {[$themenu index end] != "none"} {
	    for {set i 0} {$i <= [$themenu index end]} {incr i} {
		set type [$themenu type $i]

		if {$type == "command"} {
		    set command [$themenu entrycget $i -command]

		    if {[info procs [lindex $command 0]] == ""} {
			$themenu entryconfigure $i -foreground red
		    }
		}
	    }
	}
    }
}

