# TCLSADIE_CC_POSIXCSOURCE_FLAG
# -----------------------------
AC_DEFUN([TCLSADIE_CC_POSIXCSOURCE_FLAG],
[AC_REQUIRE([AC_PROG_CC])dnl
  AC_CACHE_CHECK([whether $CC accepts a flag to enable POSIX features],
                 [tclsadie_cv_cc_posixcsource_flag],
                 tclsadie_posix_version=`getconf _POSIX_VERSION 2>/dev/null`
                 if test "x${tclsadie_posix_version}" = "x" ; then
                   tclsadie_cv_cc_posixcsource_flag=""
                 else
                   tclsadie_old_CPPFLAGS="${CPPFLAGS}"
                   for tclsadie_cv_cc_posixcsource_flag in "" "-D_POSIX_C_SOURCE=${tclsadie_posix_version}" "MISSING"
                   do
                     CPPFLAGS="${tclsadie_old_CPPFLAGS} ${tclsadie_cv_cc_posixcsource_flag}"
                     AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <sys/types.h>
#include <unistd.h>
]],[[long v; v = 
#ifdef _POSIX_C_SOURCE
_POSIX_VERSION
#endif
;]])],
                                       break)
                   done
                 fi
                 CPPFLAGS="${tclsadie_old_CPPFLAGS}")
  case "x${tclsadie_cv_cc_posixcsource_flag}" in
    x)
      ;;
    xMISSING)
      ;;
    *)
      CPPFLAGS="${CPPFLAGS} ${tclsadie_cv_cc_posixcsource_flag}" ;;
  esac
])# TCLSADIE_CC_POSIXCSOURCE_FLAG

