/** @file project_utilities.h
 * General utilities for portable C projects.
 *
 * @author University of Arizona Digital Image Analysis Lab
 * @date 1999, 2004
 * @version $Id: project_utilities.h,v 1.1 2005/03/22 20:31:48 mmunro Exp $
 */

/* This file is part of tclSadie.

   tclSadie is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   tclSadie is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with tclSadie; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.  */

#ifndef PROJECT_UTILITIES_H
/** The standard guard against including the same header twice. */
#define PROJECT_UTILITIES_H 1

#ifdef __cplusplus
/** The standard preamble to include C code in C++ programs. */ 
#  define BEGIN_C_DECLARATIONS extern "C" {
/** Close a series of C declarations in a C++ context. */ 
#  define END_C_DECLARATIONS }
#else
/** An empty preamble for C code unmixed with C++. */
#  define BEGIN_C_DECLARATIONS
/** An empty coda for C declarations outwith a C++ context. */
#  define END_C_DECLARATIONS
#endif

#endif
